; ========================================================================================
; RS-232C software serial communication program
; From http://www.picfun.com/docs/rs232cv2.asm
; TO SEND
;   Set data to TXREG then call PUTCHAR, TXBUSY will go down when transmission has done.
; TO RECV
;   Call GETCHAR, data will be available when RECV go up without ERROR
; CONNECTION
;   RXD (PIN3 RA4) Pin constrained because this function uses hardware timer interruption.
;   TXD (PIN4 RB4) Can use any pin. Placed by PCB layout.

;*************************************
;  vZX
;*************************************
OPEN232
	CLRF	RESULT		;Xe[^X̃NA
	BSF		STATUS,RP0	;Set page 1
	BCF		TRISB,4		;Set TXD (RB4) 
	BSF		TRISA,4		;Set RXD (RA4)
	BCF		STATUS,RP0	;Set Page 0
	;BSF		PORTA,5		;TXD SET TO H
	BSF		PORTB,4
	;BSF		INTCON,GIE
	RETURN

;************************************
; PoCgMvZX
;@Mf[^TXREGɃZbgCALL
;************************************
PUTCHAR
	BSF		TXBUSY		;MrW[Zbg
	MOVLW	8			;rbgJE^l
	MOVWF	BITCNT		;lZbg
	MOVLW	1			;Xgbvrbg=1
	MOVWF	EXTRA		;XgbvrbgZbg
	CALL	TXSTART		;X^[grbgMJn
	BCF		INTCON,T0IF	;݃tOZbg
	BSF		INTCON,T0IE 	;^C}0݋
	RETURN
;**** X^[grbgM ****
TXSTART
	CLRF	TMR0			;^C}Zbg
	BSF		STATUS,RP0	;page 1
	;CLRWDT				;don't care
	MOVLW	BAUDRATE		;set prescaler
	MOVWF	OPTION_REG
	BCF		STATUS,RP0	;page 0 
	;BCF		PORTA,5		;X^[grbgo
	;BCF		PORTB,3
	bcf		PORTB, TXD
	MOVLW	BITTMR		;rbg^C}Zbg
	MOVWF	TMR0			;start timer
	RETURN

;*************************************
;  PoCgMvZX
;*************************************
GETCHAR
	BCF		RECV			;MtONA
	MOVLW	9			;rbgJE^l
	MOVWF	BITCNT		;lZbg
	CLRF	RXREG		;obt@NA
	BCF		RXERR		;G[tONA
;****  X^[grbgM҂  ****
	CLRF	TMR0			;^C}Zbg
	BSF		STATUS,RP0	;page 1
	;CLRWDT				;dont't care
	;MOVLW	038H
	MOVLW	0B8H			; with /RBPU
	MOVWF	OPTION_REG
	BCF		STATUS,RP0	;page 0
	MOVLW	0FFH			;tJEglZbg
	MOVWF	TMR0			;
	BCF		INTCON,T0IF	;^C}0݃tOZbg
	BSF		INTCON,T0IE	;^C}0݋
	RETURN				;ݑ҂

;****************************************
; Interrupt process module
;****************************************
INT232
	;BTFSS	INTCON,T0IF	;TMR0's interrupt?
	;RETFIE				;not, quick return
	BCF		INTCON,T0IF	;reset T0IF bit
	
;****  save W register & status register
	;MOVWF	WREG			;save w reg
	;SWAPF	STATUS,W		;status to wreg
	;CLRF	STATUS
	;MOVWF	SREG        	;save status

	BTFSC	TXBUSY		;MH
	GOTO	TXNEXT		;Mݏ
	BTFSC	RXBUSY		;MH
	GOTO	RXNEXT		;Mݏ
	GOTO	STARTBIT		;X^[grbgM
;****  register restore and return
RESTORE
	SWAPF	SREG,W		;get saved status
	MOVWF	STATUS
	SWAPF	WREG,F		;get saved wreg
	SWAPF	WREG,W
	RETFIE

;***************************************
;  MݏvZX
;***************************************
TXNEXT
	MOVLW	BITTMR		;^C}OăX^[g
	MOVWF	TMR0
	MOVF	BITCNT,W		;rbgJEgmF
	BTFSC	STATUS,Z		;rbgI
	GOTO	STOPBIT		;XgbvrbgM
NEXTTXBIT
	DECF	BITCNT,F		;rbgJE^Z
	BSF		STATUS,C		;C on
	RRF		TXREG,F		;Mf[^Vtg
	BTFSS	STATUS,C		;OP
	bcf		PORTB, TXD
	BTFSC	STATUS,C
	bsf		PORTB, TXD
	GOTO	RESTORE		;return
;****  XgbvrbgMvZX  ****
STOPBIT
	MOVF	EXTRA,W		;XgbvrbgM
	BTFSC	STATUS,Z		;end test
	GOTO	DONE			;SrbgM
	DECF	EXTRA,F		;XgbvrbgZ
	bsf		PORTB, TXD
	GOTO	RESTORE		;߂
;***  all end of send ****
DONE
	;bsf		STATUS, RP0	;page 1
	;MOVLW	0B8H
	;MOVWF	OPTION_REG
	;bcf		STATUS, RP0	;page 0
	;bcf		INTCON, T0IF
	BCF		INTCON,T0IE	;^C}O݋֎~
	BCF		TXBUSY		;MrW[tONA
	GOTO	RESTORE		;߂

;*****************************************
;@X^[grbgMݏvZX
;*****************************************
STARTBIT
	; CLRWDT				;WDTZbg
	; Don't care noise due to onboard USB-Serial converter. Save CPU cycles.
	;CALL	TIME10		;10usecx
	;BTFSC	PORTA,4		;ēxX^[grbgmF
	;GOTO	NOISE		;G[^[
	BSF		RXBUSY		;MrW[Zbg
	CLRF	TMR0			;^C}
	BSF		STATUS,RP0	;page 1
	MOVLW	BAUDRATE		;rbgZbg
	MOVWF	OPTION_REG
	BCF		STATUS,RP0	;page 0
	MOVLW	BITTMR1		;rbg1.1{Zbg
	MOVWF	TMR0			;X^[grbgXLbv
	GOTO 	RESTORE		;߂
;*** X^[grbgG[iȂj ****
;NOISE       
;	MOVLW	0FFH		;ēxX^[grbgM҂
;	MOVWF	TMR0
;	GOTO	RESTORE		;߂

;*****************************************
;@MݏvZX
;*****************************************
RXNEXT
	BSF		STATUS,RP0	;page 1
	;CLRWDT				;^C}
	MOVLW	BAUDRATE
	MOVWF	OPTION_REG
	BCF		STATUS,RP0	;page 0
	MOVLW	BITTMR
	MOVWF	TMR0			;ăX^[g
	DECFSZ	BITCNT,F		;rbgJEgIH
	GOTO	NEXTRXBIT
;*** XgbvrbgM  ***
	BTFSS	PORTA,4		;Xgbvrbg̊mF
	BSF		RXERR		;G[tOON
	BCF		INTCON,T0IE	;݋֎~
	BCF		RXBUSY		;MrW[tONA
	BSF		RECV			;Mf[^LtOZbg
	GOTO	RESTORE

;**** c̃rbgM  ***
NEXTRXBIT
	BCF		STATUS,C		;rbgOZbg
	BTFSC	PORTA,4		;MrbgOP
	BSF		STATUS,C		;1 ̎PɃZbg
	RRF		RXREG,F		;RXREGɂPrbg
	GOTO	RESTORE		;߂

;*****  10usec x^C}
;TIME10                  ;10usec
;	MOVLW	15
;	MOVWF	CNT2        
;T_LP2
;	DECFSZ	CNT2,F		;2+3*15-1=46     
;	GOTO	T_LP2       
;	RETURN				;46+2=48

;********  End of RS-232C software serial communication program ***********
;**************************************************************************
